{% load static %}

<head>
  <title>Secuencias de Consultas</title>

  {% include 'sub_templates/base.html' %}
  {{'caja_gris/escritura_secuencia.scss'|css_compiler|safe}}

  <script type="text/javascript">
    $( document ).ready( function (){
      //asignar el numero de los pasos
      recalculate_steps();
      
      start_unsaved_changes_messages();
    })

    function action_test_selected(data){
      window.location.href = 'http://'+window.location.host+'/{{project_id}}/caja_gris/escritura/secuencia/'+data;
    }

    function delete_data(elem){
      let parent = elem.parentNode.parentNode;
      parent.remove();

      recalculate_steps(); //volver a asignar los valores de 'Paso X'
    }

    function recalculate_steps(){
      // console.log('falta recalcular los "Paso X"')
      existant_element_texts = $('.existant-steps').children(".step").children(".order")
      for (var i = 0; i < existant_element_texts.length; i++) {
        existant_element_texts[i].innerHTML = '<step>Paso '+(i+1)+'</step>'
      }
    }

    function new_data(elem){
      let new_elem = elem.parentNode.parentNode
      let added_element = $(new_elem).clone()
      let existant_elements = new_elem.parentNode.children[0]

      added_element.removeAttr("id")
      $(existant_elements).append(added_element)

      let plus_times_elem = added_element.children(".plus")
      plus_times_elem.removeClass()
      plus_times_elem.addClass("times")
      plus_times_elem.html('<a onclick="delete_data(this);">{{"times-solid.svg"|svgColor:"var(--danger)"|safe}}</a>')

      return added_element
    }

    function new_step(elem){
      let new_elem = elem.parentNode.parentNode
      // let selected_elem = $(new_elem).children("select").children("optgroup").children("option:selected")[0]
      let selected_value = $(new_elem).children("select").val()

      if (selected_value != ""){

        let added_element = new_data(elem)
        let existant_elements = elem.parentNode.parentNode.parentNode.children[0]

        // agregar 'Paso X' y seleccionar valor de selected anterior
        added_element.children(".order")[0].innerHTML = "<step>Paso " + existant_elements.children.length + "</step>"
        added_element.children("select").children("option").remove()
        added_element.children("select").val(selected_value)

        // des-seleccionar el elemento select de 'add-new'
        $(new_elem).children("select").val(null)
      }
      else{
        $(new_elem).children("select").focus();
      }

    }

    function save_steps(){
      // aqui falta obtener la lista de pasos
      steps = [];
      $('.existant-steps select').each((i, elem) => {
        steps.push(elem.value);
      })

      $.ajax({
        url: '/sequences/save_steps/{{test_id}}',
        type: 'POST',
        data: {
          'steps': steps,
        },
        success: function(result){
          localStorage.clear();
          window.location.reload();
        },
        error: function(result){
          console.log(result);
          alert('Ocurrio un error inesperado');
        }
      });
    }

    function execute_sequence(){
      loading_message('Ejecutando secuencia');

      // aqui falta obtener la lista de pasos
      steps = [];
      $('.existant-steps select').each((i, elem) => {
        steps.push(elem.value);
      })

      $.ajax({
        url: '/sequences/execute_queries/{{test_id}}',
        type: 'POST',
        success: function(result){
          window.location.reload();
        },
        error: function(result){
          console.log(result);
          alert('Ocurrio un error inesperado');
        }
      });
    }
  </script>
</head>

<body>
  {% include 'sub_templates/left_nav_bar.html' %}

  <div class="back-button">
    <a href="/{{project_id}}/caja_gris">{{'arrow-left-solid.svg'|svgColor:'var(--secondary)'|safe}}</a>
  </div>
  <div class="content">
    <div class="title">
      {{title}}
    </div>
    <div class="steps">
      <div class="centerY">
        <div class="existant-steps">
          {% for step in steps %}
          <div class="step satisfied-{{step.query.response.satisfied}}">
            <div class="order">
            </div>
            <select class="custom-select">
            {% for section in all_routes %}
              <optgroup label="{{section}}">
                {% for route in all_routes|dict_key:section %}
                <option value="{{route.id}}" {% if route.id == step.query_id %} selected {% endif %}>{{route.title}} - {{route.method}} : {{route.route}}</option>
                {% endfor %}
              </optgroup>
            {% endfor %}
            </select>
            <div class="times">
              <a onclick="delete_data(this);">{{'times-solid.svg'|svgColor:'var(--danger)'|safe}}</a>
            </div>
          </div>
          {% endfor %}
        </div>

        <div class="step" id="new-step">
          <div class="order"><span></span></div>
          <select class="custom-select">
            <option value=""> Añadir un paso extra </option>
            {% for section in all_routes %}
            <optgroup label="{{section}}">
              {% for route in all_routes|dict_key:section %}
              <option value="{{route.id}}">{{route.title}} - {{route.method}} : {{route.route}}</option>
              {% endfor %}
            </optgroup>
            {% endfor %}
          </select>
          <div class="plus">
            <a onclick="new_step(this);">{{'plus-solid.svg'|svgColor:'var(--info)'|safe}}</a>
          </div>
        </div>
      </div>
    </div>
    <div class="save-execute centerX">
      <button id="save_test" class="btn btn-outline-info save" onclick="save_steps();"> Guardar </button>
      <button id="execute_test" class="btn btn-info execute" onclick="execute_sequence();"> Ejecutar </button>
    </div>
  </div>


</body>